#include "Puzzle_Module.h"

Puzzle_Module::Puzzle_Module() {
    puzzle_length = 5;
    puzzle_sequence = new int [puzzle_length];
    player_sequence = new int [puzzle_length];
    if (puzzle_sequence == NULL) {
        Serial.println("Error: memory could not be allocated");
        /* cout << "Error: memory could not be allocated"; */
    } else {
        for (int i = 0; i < puzzle_length ; i++ ) {
            puzzle_sequence[i] = 0;   
            player_sequence[i] = 0;   
        }
    }
}

Puzzle_Module::~Puzzle_Module() {
    delete [] puzzle_sequence;
    delete [] player_sequence;
}

void Puzzle_Module::Set_Puzzle_Length(int _puzzle_length) {
    puzzle_length = _puzzle_length;
}

int Puzzle_Module::Get_Puzzle_Length() {
    return puzzle_length;
}

void Puzzle_Module::Set_Puzzle_Sequence(int* _puzzle_sequence) {
    int seq_count = 0;
    if (puzzle_sequence == NULL) {
        Serial.println("Error: memory could not be allocated");
    } else {
        Serial.println("Enter numbers [0-4] separated by space: ");
        if (Serial.available() > 0){
        /* while(seq_count<=Sequence_Len){ */
            puzzle_sequence = Serial.read();
            /* cin >> puzzle_sequence[seq_count]; */
            seq_count++;
        }
    }
}

void Puzzle_Module::Set_Player_Sequence(int* _player_sequence) {
    player_sequence = _player_sequence;
}

void Puzzle_Module::Check_Puzzle_Sequence() {
    char check_result[20];
    int n; // Length of char array
    
    Serial.println( "Enter first digit: ");
    for (int i = 0; i<=puzzle_length ; i++) {
        if (i>0) {
            Serial.println("Enter next digit: ");
        }
        Serial.println( player_sequence[i]);
        n=sprintf (check_result, "Player: %c\tInput: %c",player_sequence[i],
                puzzle_sequence[i]);
        /* cout << player_sequence[i] << '\t' << puzzle_sequence[i] << endl; */
        /* cout << check_result << endl; */
        Serial.println(check_result);
        if (!(player_sequence[i] == puzzle_sequence[i])) {
            Serial.println( "Wrong one");
            break;
        } else {
            Serial.println("You got it right!");
        }
    }
}
