#ifndef PUZZLE_MODULE_H
#define PUZZLE_MODULE_H

#include <Arduino.h>
#include "Configuration.h"

class Puzzle_Module {
    private:
        int* player_sequence;
        int* puzzle_sequence;
        int puzzle_length;                                          // default value is 5
    public:
        Puzzle_Module();
        ~Puzzle_Module();
        void Set_Puzzle_Length(int _puzzle_length);
        int Get_Puzzle_Length();
        void Set_Player_Sequence(int* _player_sequence);
        void Set_Puzzle_Sequence(int* _puzzle_sequence);
        int* Get_Puzzle_Sequence();
        void Check_Puzzle_Sequence();
};
#endif

