#ifndef _ACCELEROMETER_H_
#define _ACCELEROMETER_H_

#include <stdio.h>
#include "Configuration.h"
#include <Arduino.h>
#include "Sensor.h"

class Accelerometer {
    public:
        Accelerometer(uint16_t _id);
        ~Accelerometer();
        void Pin_Initialise();
        void Sensor_Initialise();
        void Read_Accelerometer();
        ivec_t Get_Sensor_Info();
        /* sensors_vec_t Get_Sensor_Info(); */
        /* f_sensor_packet_t Get_Sensor_Packet(); */
        i_sensor_packet_t Get_Sensor_Packet();
    private:
        sensors_type_t type;
        ivec_t accel_data;
        /* sensors_vec_t accel_data; */
        int x_accel_pin,y_accel_pin,z_accel_pin;
        uint16_t id;
};

#endif
